/*****************************************************************************/
/* Obj.h - A library for object list.                                        */
/*                                                                           */
/* Obj.h Copyright (c) 2000 Sakai Hiroaki.                                   */
/* All Rights Reserved.                                                      */
/*****************************************************************************/

/*****************************************************************************/
/* Obj 2000/1    Sakai Hiroaki                                               */
/*===========================================================================*/
/* Υ饤֥ϡObj ֥Ȥ뤿ΤΤǤ            */
/* Obj.h 򥤥󥯥롼ɤƻȤäƤ                                  */
/* ObjP.h ϡ饤֥ѤΥץ饤١ȥإåʤΤǡ̤ˤ         */
/* 󥯥롼ɤʤȡ                                                  */
/*****************************************************************************/

#ifndef _SAKAILIB_OBJ_H_INCLUDED_
#define _SAKAILIB_OBJ_H_INCLUDED_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef void * Obj;
typedef struct _ObjListData * ObjListData;
typedef struct _ObjList * ObjList;

typedef Obj (*ObjDestructor)(Obj);

/*****************************************************************************/
/* ObjList ֥Ȥ                                              */
/*****************************************************************************/

Obj ObjListData_GetObj(ObjListData data);
Obj ObjListData_GetPrev(ObjListData data);
Obj ObjListData_GetNext(ObjListData data);
int ObjList_GetLength(ObjList list);
ObjListData ObjList_GetStartEdge(ObjList list);
ObjListData ObjList_GetEndEdge(ObjList list);
ObjListData ObjList_GetStart(ObjList list);
ObjListData ObjList_GetEnd(ObjList list);
int ObjList_IsEmpty(ObjList list);
int ObjList_IsStartEdge(ObjList list, ObjListData data);
int ObjList_IsEndEdge(ObjList list, ObjListData data);
int ObjList_IsStart(ObjList list, ObjListData data);
int ObjList_IsEnd(ObjList list, ObjListData data);
ObjListData ObjList_InsertObjToPrev(ObjList list, ObjListData current,
				    Obj obj, Obj (*destructor)());
ObjListData ObjList_InsertObjToNext(ObjList list, ObjListData current,
				    Obj obj, Obj (*destructor)());
ObjListData ObjList_InsertObjToStart(ObjList list, Obj obj,
				     Obj (*destructor)());
ObjListData ObjList_InsertObjToEnd(ObjList list, Obj obj,
				   Obj (*destructor)());
ObjListData ObjList_DeleteObjToPrev(ObjList list, ObjListData current);
ObjListData ObjList_DeleteObjToNext(ObjList list, ObjListData current);
ObjListData ObjList_DeleteObjFromStart(ObjList list);
ObjListData ObjList_DeleteObjFromEnd(ObjList list);
ObjList ObjList_Create(); /* ObjList ֥Ȥ */
ObjList ObjList_Destroy(ObjList list); /*  */
ObjList ObjList_Concatenate(ObjList list1, ObjList list2);

#endif

