#ifndef _XHANABI_RGBColor_h_INCLUDED_
#define _XHANABI_RGBColor_h_INCLUDED_

#include "Obj.h"
#include "Disp.h"
#include "Stream.h"

typedef struct _RGBColor * RGBColor;
typedef struct _RGBColorChange * RGBColorChange;

int RGBColor_GetBrightness(RGBColor rgb);
RGBColor RGBColor_Create(unsigned char red,
			 unsigned char green,
			 unsigned char blue);
RGBColor RGBColor_Destroy(RGBColor rgb);
RGBColor RGBColor_CreateFromCharacters(Disp disp, char * string);
RGBColor RGBColor_CreateFromRGBColor(RGBColor rgb_color);
RGBColor RGBColor_CreateMiddleColor(RGBColor rgb1, RGBColor rgb2, int per);
RGBColor RGBColor_CreateMiddleColorToBlack(RGBColor rgb, int per);
RGBColor RGBColor_CreateMiddleColorToWhite(RGBColor rgb, int per);
unsigned long int RGBColor_GetColor(Disp disp, RGBColor rgb);
RGBColorChange RGBColorChange_Create(RGBColor rgb1, RGBColor rgb2, int length);
RGBColorChange RGBColorChange_Destroy(RGBColorChange change);
RGBColorChange RGBColorChange_CreateFromCharacters(Disp disp,
						   char * str1, char * str2,
						   int length);
RGBColor RGBColorChangeList_GetRGBColor(ObjList list, int counter);
ObjList RGBColorChangeList_CreateFromCharacters(Disp disp, char * data);

#endif /* _XHANABI_RGBColor_h_INCLUDED_ */
