#ifndef _XHANABI_Tama_h_INCLUDED_
#define _XHANABI_Tama_h_INCLUDED_

#include "etc.h"
#include "Obj.h"
#include "GCObj.h"
#include "Stream.h"
#include "AfterImage.h"
#include "RGBColor.h"

typedef struct _TamaClass * TamaClass;
typedef struct _Tamas * Tamas;
typedef struct _TamaNext * TamaNext;

char * TamaClass_GetName(TamaClass tama_class);
double TamaClass_GetProbability(TamaClass tama_class);
ObjList TamaClass_GetGCListList(TamaClass tama_class);
ObjList TamaClass_GetNextList(TamaClass tama_class);
double TamaNext_GetPower(TamaNext tama_next);
TamaClass Tamas_GetTamaClass(Tamas tamas);
double * Tamas_GetX(Tamas tamas);
double * Tamas_GetY(Tamas tamas);
int Tamas_GetNumber(Tamas tamas);
int TamaNext_GetNumber(TamaNext tama_next);
TamaClass TamaNext_GetTamaClass(TamaNext tama_next);
TamaClass TamaClass_Create(char * name,
			   int size,
			   double probability,
			   double air,
			   int after_image_length,
			   ObjList gc_list_list,
			   ObjList next_list, Disp disp);
TamaNext TamaNext_Create(TamaClass tama_class, double power, int n);
TamaClass TamaClass_Destroy(TamaClass tama_class);
TamaNext TamaNext_Destroy(TamaNext next);
ObjList TamaClassList_CreateFromStream(Disp disp, Stream stream);
Tamas Tamas_Create(TamaClass tama_class, double power, int number,
		   int n, double * x, double * y, Disp disp);
Tamas Tamas_Destroy(Tamas tamas);
AfterImages Tamas_Move(Tamas tamas, int x_min, int y_min, int x_max, int y_max);

#endif
